; INSIST.8 (Batch file utility.)
;       1. Prints a string read from the command line.
;       2. Beeps insistently until char is input from keyboard.
;       3. Capitalizes it iff it's a lower case character, and sets
;          ERRORLEVEL at ASCII value of result.
;
; Programmer: R. N. Wisan 9/24/88

;---If there's a command line, echo it to screen
GETCOMLINE:
   SUB  CX,CX
   MOV  SI,80H      ; Point SI @ comm line in PSP
   MOV  CL,CS:[SI]  ; length of comm line -> CX
   CMP  CL,1        ; if not >1
   JLE  FIRSTRING   ;   skip display; go get char
   INC  SI          ; else pass 1st char (blank)
   DEC  CL
               ;---Show the comm line
   MOV  AH,2        ; DOS display char svc
SHOWCOMMLINE:       ;
   INC  SI          ; aim at next char
   MOV  DL,CS:[SI]  ; char -> AL
   INT  21h         ; Call DOS
   LOOP SHOWCOMMLINE ; loop CX times for comm line
   MOV  DL,20h      ; add a space
   INT  21h

;---Ring bell at intervals until char input from kbd.
FIRSTRING:
   CALL RING

WAITFORIT:     ;---Read character from Kbd & upcase it.
   MOV  CX,0800h    ; delay loop
SLOWLY:
   MOV  AH,01       ; check kbd for char ready
   INT  16h         ; BIOS kbd interrupt svs
   JNZ  GETCHAR     ; if it is, go get it
   LOOP SLOWLY
   CALL RING
   JMP  WAITFORIT   ; Loop forever

GETCHAR:
   MOV  AH,8        ; DOS char, chk ^C, no echo
   INT  21H         ; Call DOS  (Char -> AL)

UPCASE:        ;---UpCase char parked in AL
   CMP  AL,97       ; Below "a"?
   JL   SHOWCHAR    ;   if so don't change case
   CMP  AL,122      ; Above "z" ?
   JG   SHOWCHAR    ;   if so don't change case
   AND  AL,0DFH     ; Change case

SHOWCHAR:      ;---Write char to screen
   PUSH AX          ; store for SETERR
   MOV  AH,02       ; DOS display char
   MOV  DL,AL       ; Char to DL
   INT  21H         ; Do it.
   MOV  DL,0Dh      ; add a CR
   INT  21H         ; Do display
   MOV  DL,0Ah      ; add a LF
   INT  21H         ; Do display

SETERR:        ;---Exit setting error level
   POP  AX          ; UpCased char to AL
   MOV  AH,4CH      ; DOS terminate setting errorlevel
   INT  21H         ; Do it.

RING PROC NEAR ;---Ring the bell
   MOV  DL,7        ; BEL char
   MOV  AH,2        ; DOS display & chk for ^C
   INT  21h         ; Call DOS
   RET
   ENDP
