
; Insist.8 (Batch file utility.)
;       1. Prints a string read from the command line.
;       2. Beeps insistently until about 10 min has elapsed
;             or char is input from keyboard.
;       3. I time has elapsed, stops beeping but still waits for char.
;       4. Capitalizes char iff it's a lower case character, and sets
;             ERRORLEVEL at ASCII value of result.
; Programmer: R. N. Wisan 9/16/88

GETCOMLINE:
   SUB  CX,CX
   MOV  SI,80H
   MOV  CL,CS:[SI]  ; length of comm line -> CX
   CMP  CL,1        ; if not >1
   JLE  SHOWNALL    ; skip display; go get char
   INC  SI          ; pass 1st char (blank)
   DEC  CL
   MOV  AH,2        ; DOS display char

SHOWCOMMLINE:       ; Show comm line
   INC  SI          ; aim at next char
   MOV  DL,CS:[SI]  ; char -> AL
   INT  21h         ; Call DOS
   LOOP SHOWCOMMLINE ; loop CX times for comm line
   MOV  DL,20h      ; add a space
   INT  21h
SHOWNALL:

;--Read character from Kbd & upcase it.
   MOV  BX,600     ; Number of rings (10-15 min)
   CALL RING       ; On a plain 4.7MHZ PC this beeps
                   ; at 1 sec intervals.  It's faster
                   ; proportionally on faster machines.

WAITFORIT:
   MOV  CX,0700h    ; Start delay loop
SLOWLY:
   MOV  AH,01       ; chk kbd for char ready
   INT  16h         ; BIOS kbd interrupt svs
   JNZ  READKBD     ; If char's there, go get it
   LOOP SLOWLY      ; foofle CX times
   CMP  BX,0        ; Are we still ringing?
   JE   NOBEL       ; if not go round again
   DEC  BX          ; else count this one
   CALL RING        ; & ring
NOBEL: JMP WAITFORIT

READKBD:
   MOV  AH,8        ; DOS char, chk ^C, no echo
   INT  21H         ; Call DOS  (Char -> AL)

;---UpCase & display char parked in AL
UPCASE:      ;---Upcase if it's a letter
   CMP  AL,97       ; Below "a"?
   JL   SHOWCHAR    ;   if so don't change case
   CMP  AL,122      ; Above "z" ?
   JG   SHOWCHAR    ;   if so don't change case
   AND  AL,0DFH     ; Change case

SHOWCHAR:   ;---Display the char
   PUSH AX          ; store for SETERR
   MOV  AH,02       ; DOS display char
   MOV  DL,AL       ; Char to DL
   INT  21H         ; Do it.
   MOV  DL,0Dh      ; add CR
   INT  21H         ; Do display
   MOV  DL,0Ah      ; add LF
   INT  21H         ; Do display

SETERR:
   POP  AX          ; UpCased char to AL
   MOV  AH,4CH      ; DOS terminate setting errorlevel
   INT  21H         ; Do it.

RING: PROC NEAR
   MOV  DL,7        ; ring BEL
   MOV  AH,2        ; with DOS display char
   INT  21h         ; Call DOS to do it
   RET
   ENDP
